/*      dirent.h

        Copyright (c) Serge Pustovoitoff 1995-1997
*/

#include <stdio.h>

#ifndef _DIRENT_H_
#define _DIRENT_H_

#ifndef _ATTRFIELD_
#define _ATTRFIELD_
struct AttrField
{
unsigned int ReadOnly : 1;
unsigned int Hidden   : 1;
unsigned int System   : 1;
unsigned int Label    : 1;
unsigned int Dir      : 1;
unsigned int Archive  : 1;
unsigned int Attr2    : 1;
unsigned int Attr1    : 1;
};

union FileAttr
{
struct AttrField B;
unsigned char U;
};
#endif

#ifndef _FTIME_
#define _FTIME_
struct  ftime   {
        unsigned        ft_tsec  : 5;   /* Two second interval */
        unsigned        ft_min   : 6;   /* Minutes */
        unsigned        ft_hour  : 5;   /* Hours */
        unsigned        ft_day   : 5;   /* Days */
        unsigned        ft_month : 4;   /* Months */
        unsigned        ft_year  : 7;   /* Year */
};
#endif

#define d_ino           d_fileno        /* backward compatibility */
#define DIR FILE
struct dirent
{
char d_name [11];
union FileAttr Attr;
char Reserv [10];
struct ftime FileDateTime;
unsigned int d_fileno; /* initial cluster number in MSDOS/Proolix file systems */
unsigned long int Size;
};

DIR far *opendir (const char far *dirname);
#ifdef KERNEL
DIR far *openwdir (const char far *dirname);
#endif
DIR far *openidir (int inode);
struct dirent far *readdir (const DIR far *dirp);
#ifdef KERNEL
int writedir (const DIR far *dirp, struct dirent far *D);
#endif
void rewinddir (const DIR far *dirp);
int closedir (const DIR far *dirp);
long telldir (const DIR far *dirp);
long seekdir (const DIR far *dirp, long offset, int where);
int dircmp (struct dirent d1, struct dirent d2);

#endif /* !_DIRENT_H_ */
