#include <prool.h>
#include <dos.h>

#include <conf.c>

#include "kernel.h"

/* #define DEBUG */

/* NextClu(), NextClu2() - next cluster number compute and load to Cache) */
/* NextClu() - kernel's internal module */
/* NextClu2() - boot manager internal module */

/* ᮢ뢠 NextClu()  NextClu2() ! */

unsigned int NextClu (unsigned int CluNo) /* -1 for eof or error */
{
unsigned long j;
unsigned int nsect, offset, b;
unsigned int i;

if ((CluNo>MaxClusters)||(CluNo==0))
  {
  printf("NextClu: Invalid cluster number. CluNo=%u, MaxClusters=%u",
  CluNo, MaxClusters);
  return -1;
  }

if (FATMode==FAT12)
  { /* FAT 12 */
  /* ।塞    ⠡ FAT-12 */
  j=(CluNo*3)/2;
  /* ।塞  ᥪ FAT */
  nsect=(unsigned int)(j/SECTOR_SIZE);
  #ifdef DEBUG
  printf("nsect=%i ",nsect);
  #endif
  /* nsect-⭮⥫  ᥪ FAT. 0 -  ᥪ FAT */
  if (nsect>=FatSize) {puts("NextClu: Invalid FAT's computing"); return -1;}
  if ( (b=LoadCache(ResSecs+nsect)) == -1U )
    {puts("\nNextClu: FAT read error"); return -1;}

  offset=(unsigned int)(j%SECTOR_SIZE);
  #ifdef DEBUG
  printf("offset=%i ",offset);
  #endif
  if (offset==(SECTOR_SIZE-1))
    {unsigned char c;
    c=*(unsigned char far *)((*(Cache+b)).M+(SECTOR_SIZE-1));
    if ( (b=LoadCache(ResSecs+nsect+1)) == -1U )
      {puts("\nNextClu: FAT read error"); return -1;}
    #ifdef DEBUG
    printf("c=%04X ",c);
    #endif
    i=((unsigned int)c)|
    (((unsigned int)(*(unsigned char far *)((*(Cache+b)).M)))<<8);
    }
  else
    i=*(int far *)((*(Cache+b)).M+offset);
  #ifdef DEBUG
  printf("word=%04X ",i);
  #endif
  if (CluNo & 1)
    {
    #ifdef DEBUG
    putch('n');
    #endif
    i>>=4;
    }
  else
    {
    #ifdef DEBUG
    putch('c');
    #endif
    i&=0xfff;
    }
  if (i>0xff0) return -1;
  }
else
  { /* FAT 16 */
  /* ।塞    ⠡ FAT-16 */
  j=((long)CluNo)*2;
  /* ।塞  ᥪ FAT */
  nsect=(unsigned int)(j/SECTOR_SIZE);
  /* nsect-⭮⥫  ᥪ FAT. 0 -  ᥪ FAT */
  if (nsect>=FatSize) {puts("NextClu: Invalid FAT's computing"); return -1;}
  if ( (b=LoadCache(ResSecs+nsect)) == -1U )
    {puts("\nNextClu: FAT read error"); return -1;}

  offset=(unsigned int)(j%SECTOR_SIZE);
  i=*(int far *)((*(Cache+b)).M+offset);
  if (i>0xfff0) return -1;
  }

#ifdef DEBUG
printf("%i->%i ",CluNo,i);
#endif

return i;
}
