#include <prool.h>

#include <conf.c>
#include "kernel.h"

/* #define DEBUG */

putch__(char c)
{
switch (c)
  {
  case 0: c=' '; break;
  default: if (c<' ') c='.';
  }
return putch(c);
}

void out_boot(void far *buf)

{int i;
unsigned long DiskSize;
unsigned long TrueSectors;
struct BootStru far *b;
b=buf;
printf("\n\
----------------------------------Disk parameters:------------------------------\n\
Jump command %02X %02X %02X  \n\
OEM name     %-8s\n\
OEM name     ",
(*b).Jmp[0], (*b).Jmp[1], (*b).Jmp[2],
(*b).OEM);

for(i=0;i<8;) printf("%02X ",(*b).OEM[i++]);

#if 0
printf("\n\
Sector size                      %4i bytes Cluster size                %1i sect\n\
Reserved sectors (before 1st FAT)  %2i       FAT counter                 %1i\n\
Root directory entries           %4i       Total sectors         %7u\n\
Media descr                        %02X       FAT size                %5i sect\n\
Track size                         %2i sec   Heads                      %2i\n\
Hidden sectors                %7li       Big Number Of Sectors %7li\n\
Physical Drive No                  %02X       Extended Boot Signature  %02X\n\
Volume Serial No %04X-%04X -----------------------------------------------------\n",
(*b).SectSiz,
(*b).ClustSiz,
(*b).ResSecs,
(*b).FatCnt,
(*b).RootSiz,
(*b).TotSecs,
(*b).Media,
(*b).FatSize,
(*b).TrkSecs,
(*b).HeadCnt,
(*b).HidnSec,
(*b).BigSect,
(*b).DriveNo,
(*b).BootSign,
(*b).SerialNo[1],
(*b).SerialNo[0]);
#endif

#ifdef DEBUG
printf(" W0 ");
#endif

printf("\nVolume Label (in boot)  ");
for(i=0;i<11;)putch__((*b).VolLbl[i++]);
printf("\n                        ");
for(i=0;i<11;)printf("%02X ",(*b).VolLbl[i++]);
printf("\nFile system Id          ");
for(i=0;i<8;)putch__((*b).FileSysId[i++]);
printf("\n                        ");
for(i=0;i<8;)printf("%02X ",(*b).FileSysId[i++]);

if ((*b).TotSecs==0) TrueSectors=(*b).BigSect;
else TrueSectors=(*b).TotSecs;

#ifdef DEBUG
printf(" W1 ");
#endif

DiskSize=((long) (*b).SectSiz * TrueSectors)/1024l;

#ifdef DEBUG
printf(" W2 ");
#endif

if (DiskSize>5000)
  {
  #ifdef DEBUG
  printf(" W3 ");
  #endif
  DiskSize/=1024;
  #ifdef DEBUG
  printf(" W4 ");
  #endif
  printf("\nDisk size %li Mb\n",DiskSize);
  }
else
  {
  printf("\nDisk size %li Kb\n",DiskSize);
  }

}
